package com.soundapp.alisajung.ambientsounds;

import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.net.Uri;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.util.SparseBooleanArray;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;

import java.io.IOException;
import java.util.ArrayList;

public class PlaylistEditor extends AppCompatActivity implements AdapterView.OnItemClickListener {


    private ContentResolver contentResolver;
    private static String LOGTAG = "Media Importer";
    private ListView mediaListView;
    private Context context;
    private ArrayList<Long> arrayListIds;
    private ArrayAdapter arrayAdapater;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_playlist_editor);

        mediaListView = (ListView) findViewById(R.id.medialist1);

        Intent intent = getIntent();

        int message = intent.getIntExtra(ManagePlaylistsActivity.EDIT_MODE,-1);
        if (message == ManagePlaylistsActivity.PLAYLIST_ADD){

            arrayListIds = new ArrayList<Long>();
            mediaListView.setOnItemClickListener(this);
            Log.d("Hilfe", "bla5");
            loadMedia();
            Log.d("Hilfe", "bla3");

        }
        else if (message == ManagePlaylistsActivity.PLAYLIST_EDIT){
            //Auch media laden
            //außerdem die auswählen, die in playlist sind
            //iwie plalist reingeben
            //todo todo todo
        }
        else{
            Log.d("Hilfe", "FUCK FUCK FUCK "+message + " sollte " + ManagePlaylistsActivity.PLAYLIST_ADD);
        }
    }

    private void loadMedia() {
        Uri uri = android.provider.MediaStore.Audio.Media.EXTERNAL_CONTENT_URI;
        Cursor cursor = getContentResolver().query(uri, null, null, null, null);
        long lastid = 0;


        if (cursor == null) {
            Log.d(LOGTAG, "Cursor fail");
            // query failed, handle error.
        } else if (!cursor.moveToFirst()) {
            Log.d(LOGTAG, "Curser move fist fail");
            // no media on the device
        } else {
            Log.d(LOGTAG, "Stuff.");

            ArrayList arrayListTitles = new ArrayList();
            Log.d(LOGTAG, "Create adapter");
            arrayAdapater = new ArrayAdapter(getApplicationContext(), android.R.layout.simple_list_item_1, arrayListTitles);
            Log.d(LOGTAG, "Set adapter");
            mediaListView.setAdapter(arrayAdapater);
            Log.d(LOGTAG, "Do cursor stuff");
            int titleColumn = cursor.getColumnIndex(android.provider.MediaStore.Audio.Media.TITLE);
            int idColumn = cursor.getColumnIndex(android.provider.MediaStore.Audio.Media._ID);
            do {
                long thisId = cursor.getLong(idColumn);
                String thisTitle = cursor.getString(titleColumn);

                Log.d(LOGTAG, "Logging!" + thisTitle);
                // ...process entry...
                lastid = thisId;
                arrayListTitles.add(thisTitle);
                arrayListIds.add(thisId);
            } while (cursor.moveToNext());

//            playSongWithID(lastid);

        }
    }

    public void playSongWithID(long id){
        Log.d(LOGTAG, "Try playing ");
        Uri contentUri = ContentUris.withAppendedId(
                android.provider.MediaStore.Audio.Media.EXTERNAL_CONTENT_URI, id);

        MediaPlayer mMediaPlayer = new MediaPlayer();
        mMediaPlayer.setAudioStreamType(AudioManager.STREAM_MUSIC);
        try {
            mMediaPlayer.setDataSource(getApplicationContext(), contentUri);
        } catch (IOException e) {
            Log.d(LOGTAG, "Fail. mist.");
            e.printStackTrace();
        }
        try {
            mMediaPlayer.prepare();
        } catch (IOException e) {
            e.printStackTrace();
        }
        mMediaPlayer.start();
    }

    public void savePlaylist(View view){
        TextView titleview = (TextView) findViewById(R.id.editText);
        String title = titleview.getText().toString();

        SparseBooleanArray checked = mediaListView.getCheckedItemPositions();
        ArrayList<Long> selected = new ArrayList<Long>();
        int count = mediaListView.getCount();
        for (int i = 0; i < count; i++) {
            if (checked.get(i)) {
                // Do something
                Log.d("Item ", i + " is checked.");
                selected.add(arrayListIds.get(i));
            } else Log.d("is not ", "checked");
        }
        Log.d("Hi", "array done");

        Playlist p = new Playlist(title,selected);
        Intent intent = new Intent();
        intent.putExtra("New Playlist",p);
        int resultCode = ManagePlaylistsActivity.RESULT_NEW_PLAYLIST;
        setResult(resultCode, intent);
        finish();

    }

    public void abort(View view){
        Intent intent = new Intent();
        setResult(ManagePlaylistsActivity.RESULT_CANCEL,intent);
        finish();
    }

    public void deleteList(View view){
        Log.d("TODO", "delete playlist");
        Intent intent = new Intent();
        setResult(ManagePlaylistsActivity.RESULT_DELETED);
        finish();
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        Log.d(LOGTAG, "Item clicked");
        playSongWithID(arrayListIds.get(position));
    }

}
